source: common/func_validate_configs.sh@ f4ed135

2.3 2.3.x 2.4 ablfs ablfs-more legacy new_features trunk
Last change on this file since f4ed135 was f4ed135, checked in by Manuel Canales Esparcia <manuel@…>, 18 years ago

Merged r2954:3058 from experimental.

  • Property mode set to 100644
File size: 12.5 KB
Line 
1# $Id$
2
3declare -r dotSTR=".................."
4
5#----------------------------#
6validate_target() { #
7#----------------------------#
8 local -r ERROR_MSG_pt1='The variable \"${L_arrow}TARGET${R_arrow}\" value ${L_arrow}${BOLD}${TARGET}${R_arrow} is invalid for the ${L_arrow}${BOLD}${ARCH}${R_arrow} architecture'
9 local -r ERROR_MSG_pt2=' check the config file ${BOLD}${GREEN}\<$(echo $PROGNAME | tr [a-z] [A-Z])/config\> or \<common/config\>${OFF}'
10
11 local -r PARAM_VALS='TARGET${dotSTR:6} ${L_arrow}${BOLD}${TARGET}${OFF}${R_arrow}'
12 local -r PARAM_VALS2='TARGET32${dotSTR:8} ${L_arrow}${BOLD}${TARGET32}${OFF}${R_arrow}'
13
14 write_error_and_die() {
15 echo -e "\n${DD_BORDER}"
16 echo -e "`eval echo ${ERROR_MSG_pt1}`" >&2
17 echo -e "`eval echo ${ERROR_MSG_pt2}`" >&2
18 echo -e "${DD_BORDER}\n"
19 exit 1
20 }
21
22 if [[ ! "${TARGET32}" = "" ]]; then
23 echo -e "`eval echo $PARAM_VALS2`"
24 fi
25 echo -e "`eval echo $PARAM_VALS`"
26
27 case "${ARCH}" in
28 "x86") [[ "${TARGET}" = "i486-pc-linux-gnu" ]] && return
29 [[ "${TARGET}" = "i586-pc-linux-gnu" ]] && return
30 [[ "${TARGET}" = "i686-pc-linux-gnu" ]] && return
31 ;;
32 "ppc") [[ "${TARGET}" = "powerpc-unknown-linux-gnu" ]] && return
33 ;;
34 "mips") [[ "${TARGET}" = "mipsel-unknown-linux-gnu" ]] && return
35 [[ "${TARGET}" = "mips-unknown-linux-gnu" ]] && return
36 ;;
37 "sparc") [[ "${TARGET}" = "sparcv9-unknown-linux-gnu" ]] && return
38 ;;
39 "x86_64-64") [[ "${TARGET}" = "x86_64-unknown-linux-gnu" ]] && return
40 ;;
41 "mips64-64") [[ "${TARGET}" = "mips64el-unknown-linux-gnu" ]] && return
42 [[ "${TARGET}" = "mips64-unknown-linux-gnu" ]] && return
43 ;;
44 "sparc64-64") [[ "${TARGET}" = "sparc64-unknown-linux-gnu" ]] && return
45 ;;
46 "alpha") [[ "${TARGET}" = "alpha-unknown-linux-gnu" ]] && return
47 ;;
48 "x86_64") [[ "${TARGET}" = "x86_64-unknown-linux-gnu" ]] &&
49 [[ "${TARGET32}" = "i686-pc-linux-gnu" ]] && return
50 ;;
51 "mips64") [[ "${TARGET}" = "mips64el-unknown-linux-gnu" ]] &&
52 [[ "${TARGET32}" = "mipsel-unknown-linux-gnu" ]] && return
53
54 [[ "${TARGET}" = "mips64-unknown-linux-gnu" ]] &&
55 [[ "${TARGET32}" = "mips-unknown-linux-gnu" ]] && return
56 ;;
57 "sparc64") [[ "${TARGET}" = "sparc64-unknown-linux-gnu" ]] &&
58 [[ "${TARGET32}" = "sparc-unknown-linux-gnu" ]] && return
59 ;;
60 "ppc64") [[ "${TARGET}" = "powerpc64-unknown-linux-gnu" ]] &&
61 [[ "${TARGET32}" = "powerpc-unknown-linux-gnu" ]] && return
62 ;;
63 "arm") [[ "${TARGET}" = "arm-unknown-linux-gnu" ]] && return
64 ;;
65 *) write_error_and_die
66 ;;
67 esac
68
69 # If you end up here then there was an error SO...
70 write_error_and_die
71}
72
73
74#----------------------------#
75validate_config() { # Are the config values sane (within reason)
76#----------------------------#
77: <<inline_doc
78 Validates the configuration parameters. The global var PROGNAME selects the
79 parameter list.
80
81 input vars: none
82 externals: color constants
83 PROGNAME (lfs,clfs,hlfs)
84 modifies: none
85 returns: nothing
86 on error: write text to console and dies
87 on success: write text to console and returns
88inline_doc
89
90 # First internal variables, then the ones that change the book's flavour, and lastly system configuration variables
91 local -r hlfs_PARAM_LIST="BOOK BUILDDIR SRC_ARCHIVE GETPKG RUNMAKE MODEL GRSECURITY_HOST TEST BOMB_TEST OPTIMIZE REPORT COMPARE RUN_ICA RUN_FARCE ITERATIONS STRIP FSTAB CONFIG GETKERNEL KEYMAP PAGE TIMEZONE LANG LC_ALL LUSER LGROUP"
92 local -r clfs_PARAM_LIST="BOOK BUILDDIR SRC_ARCHIVE GETPKG RUNMAKE METHOD ARCH TARGET TEST BOMB_TEST OPTIMIZE REPORT COMPARE RUN_ICA RUN_FARCE ITERATIONS STRIP FSTAB BOOT_CONFIG CONFIG GETKERNEL KEYMAP VIMLANG PAGE TIMEZONE LANG LUSER LGROUP"
93 local -r clfs2_PARAM_LIST="BOOK BUILDDIR SRC_ARCHIVE GETPKG RUNMAKE ARCH TARGET OPTIMIZE REPORT STRIP FSTAB CONFIG GETKERNEL KEYMAP VIMLANG PAGE TIMEZONE LANG LUSER LGROUP"
94 local -r lfs_PARAM_LIST="BOOK BUILDDIR SRC_ARCHIVE GETPKG RUNMAKE TEST BOMB_TEST OPTIMIZE REPORT COMPARE RUN_ICA RUN_FARCE ITERATIONS STRIP FSTAB CONFIG GETKERNEL VIMLANG PAGE TIMEZONE LANG LUSER LGROUP"
95 local -r blfs_PARAM_LIST="BRANCH_ID BLFS_ROOT BLFS_XML TRACKING_DIR"
96
97 local -r ERROR_MSG_pt1='The variable \"${L_arrow}${config_param}${R_arrow}\" value ${L_arrow}${BOLD}${!config_param}${R_arrow} is invalid,'
98 local -r ERROR_MSG_pt2=' check the config file ${BOLD}${GREEN}\<$(echo $PROGNAME | tr [a-z] [A-Z])/config\> or \<common/config\>${OFF}'
99 local -r PARAM_VALS='${config_param}${dotSTR:${#config_param}} ${L_arrow}${BOLD}${!config_param}${OFF}${R_arrow}'
100
101 local PARAM_LIST=
102 local config_param
103 local validation_str
104 local save_param
105
106 write_error_and_die() {
107 echo -e "\n${DD_BORDER}"
108 echo -e "`eval echo ${ERROR_MSG_pt1}`" >&2
109 echo -e "`eval echo ${ERROR_MSG_pt2}`" >&2
110 echo -e "${DD_BORDER}\n"
111 exit 1
112 }
113
114 validate_against_str() {
115 # This is the 'regexp' test available in bash-3.0..
116 # using it as a poor man's test for substring
117 echo -e "`eval echo $PARAM_VALS`"
118 if [[ ! "$1" =~ "x${!config_param}x" ]] ; then
119 # parameter value entered is no good
120 write_error_and_die
121 fi
122 }
123
124 validate_file() {
125 # For parameters ending with a '+' failure causes a warning message only
126 echo -n "`eval echo $PARAM_VALS`"
127 while test $# -gt 0 ; do
128 case $1 in
129 # Failures caused program exit
130 "-z") [[ -z "${!config_param}" ]] && echo "${tab_}<-- NO file name given" && write_error_and_die ;;
131 "-e") [[ ! -e "${!config_param}" ]] && echo "${tab_}<-- file does not exist" && write_error_and_die ;;
132 "-s") [[ ! -s "${!config_param}" ]] && echo "${tab_}<-- file has zero bytes" && write_error_and_die ;;
133 "-r") [[ ! -r "${!config_param}" ]] && echo "${tab_}<-- no read permission " && write_error_and_die ;;
134 "-w") [[ ! -w "${!config_param}" ]] && echo "${tab_}<-- no write permission" && write_error_and_die ;;
135 "-x") [[ ! -x "${!config_param}" ]] && echo "${tab_}<-- file cannot be executed" && write_error_and_die ;;
136 # Warning messages only
137 "-z+") [[ -z "${!config_param}" ]] && echo && return ;;
138 esac
139 shift 1
140 done
141 echo
142 }
143
144 validate_dir() {
145 # For parameters ending with a '+' failure causes a warning message only
146 echo -n "`eval echo $PARAM_VALS`"
147 while test $# -gt 0 ; do
148 case $1 in
149 "-z") [[ -z "${!config_param}" ]] && echo "${tab_}NO directory name given" && write_error_and_die ;;
150 "-d") [[ ! -d "${!config_param}" ]] && echo "${tab_}This is NOT a directory" && write_error_and_die ;;
151 "-w") if [[ ! -w "${!config_param}" ]]; then
152 echo "${nl_}${DD_BORDER}"
153 echo "${tab_}${RED}You do not have ${L_arrow}write${R_arrow}${RED} access to the directory${OFF}"
154 echo "${tab_}${BOLD}${!config_param}${OFF}"
155 echo "${DD_BORDER}${nl_}"
156 exit 1
157 fi ;;
158 # Warnings only
159 "-w+") if [[ ! -w "${!config_param}" ]]; then
160 echo "${nl_}${DD_BORDER}"
161 echo "${tab_}WARNING-- You do not have ${L_arrow}write${R_arrow} access to the directory${OFF}"
162 echo "${tab_} -- ${BOLD}${!config_param}${OFF}"
163 echo "${DD_BORDER}"
164 fi ;;
165 "-z+") [[ -z "${!config_param}" ]] && echo "${tab_}<-- NO directory name given" && return
166 esac
167 shift 1
168 done
169 echo
170 }
171
172 set +e
173 PARAM_GROUP=${PROGNAME}_PARAM_LIST
174 for config_param in ${!PARAM_GROUP}; do
175 # This is a tricky little piece of code.. executes a cmd string.
176 case $config_param in
177 TIMEZONE) echo -e "`eval echo $PARAM_VALS`" ;;
178
179 # Validate general parameters..
180 GETPKG) validate_against_str "xnx xyx" ;;
181 GETKERNEL ) if [[ -z "$CONFIG" ]] && [[ -z "$BOOT_CONFIG" ]] ; then
182 [[ "$GETPKG" = "y" ]] && validate_against_str "xnx xyx"
183 fi ;;
184 RUNMAKE) validate_against_str "xnx xyx" ;;
185 REPORT) validate_against_str "xnx xyx"
186 if [[ "${!config_param}" = "y" ]]; then
187 if [[ `type -p bc` ]]; then
188 continue
189 else
190 echo -e " ${BOLD}The bc binary was not found${OFF}"
191 echo -e " The SBU and disk usage report creation will be skiped"
192 REPORT=n
193 continue
194 fi
195 fi ;;
196 COMPARE) if [[ ! "$COMPARE" = "y" ]]; then
197 validate_against_str "xnx xyx"
198 else
199 if [[ ! "${RUN_ICA}" = "y" ]] && [[ ! "${RUN_FARCE}" = "y" ]]; then
200 echo "${nl_}${DD_BORDER}"
201 echo "You have elected to analyse your build but have failed to select a tool." >&2
202 echo "Edit /common/config and set ${L_arrow}${BOLD}RUN_ICA${R_arrow} and/or ${L_arrow}${BOLD}RUN_FARCE${R_arrow} to the required values" >&2
203 echo "${DD_BORDER}${nl_}"
204 exit 1
205 fi
206 fi ;;
207 RUN_ICA) [[ "$COMPARE" = "y" ]] && validate_against_str "xnx xyx" ;;
208 RUN_FARCE) [[ "$COMPARE" = "y" ]] && validate_against_str "xnx xyx" ;;
209 ITERATIONS) [[ "$COMPARE" = "y" ]] && validate_against_str "x2x x3x x4x x5x" ;;
210 TEST) validate_against_str "x0x x1x x2x x3x" ;;
211 BOMB_TEST) [[ ! "$TEST" = "0" ]] && validate_against_str "xnx xyx" ;;
212 OPTIMIZE) validate_against_str "x0x x1x x2x" ;;
213 STRIP) validate_against_str "xnx xyx" ;;
214 VIMLANG) validate_against_str "xnx xyx" ;;
215 MODEL) validate_against_str "xglibcx xuclibcx" ;;
216 PAGE) validate_against_str "xletterx xA4x" ;;
217 METHOD) validate_against_str "xchrootx xbootx" ;;
218 ARCH) validate_against_str "xx86x xx86_64x xx86_64-64x xsparcx xsparc64x xsparc64-64x xmipsx xmips64x xmips64-64x xppcx xppc64x xalphax xarmx" ;;
219 TARGET) validate_target ;;
220 LUSER) echo -e "`eval echo $PARAM_VALS`"
221 [[ "${!config_param}" = "**EDIT ME**" ]] && write_error_and_die
222 ;;
223 LGROUP) echo -e "`eval echo $PARAM_VALS`"
224 [[ "${!config_param}" = "**EDIT ME**" ]] && write_error_and_die
225 ;;
226 GRSECURITY_HOST) validate_against_str "xnx xyx" ;;
227
228 # BOOK validation. Very ugly, need be fixed
229 BOOK) if [[ "${WC}" = "1" ]] ; then
230 validate_dir -z -d
231 else
232 validate_against_str "x${PROGNAME}-${LFSVRS}x"
233 fi ;;
234
235 # Validate directories, testable states:
236 # fatal -z -d -w,
237 # warning -z+ -w+
238 SRC_ARCHIVE) [[ "$GETPKG" = "y" ]] && validate_dir -z+ -d -w+ ;;
239 BUILDDIR) # The build directory/partition MUST exist and be writable by the user
240 validate_dir -z -d -w
241 [[ "xx x/x" =~ "x${!config_param}x" ]] &&
242 write_error_and_die
243 ;;
244
245 # Validate files, testable states:
246 # fatal -z -e -s -w -x -r,
247 # warning -z+
248 FSTAB) validate_file -z+ -e -s ;;
249 CONFIG) validate_file -z+ -e -s ;;
250 BOOT_CONFIG) [[ "${METHOD}" = "boot" ]] && validate_file -z -e -s ;;
251
252 # Treatment of 'special' parameters
253 LANG | \
254 LC_ALL) # See it the locale values exist on this machine
255 echo -n "`eval echo $PARAM_VALS`"
256 [[ -z "${!config_param}" ]] &&
257 echo " -- Variable $config_param cannot be empty!" &&
258 write_error_and_die
259 echo
260 ;;
261 KEYMAP) echo "`eval echo $PARAM_VALS`"
262 save_param=${KEYMAP}
263 [[ ! "${!config_param}" = "none" ]] &&
264 KEYMAP="/usr/share/kbd/keymaps/${KEYMAP}" &&
265 validate_file -z -e -s
266 KEYMAP=${save_param}
267 ;;
268
269 # BLFS params. No validation is required/allowed, IMHO
270 BRANCH_ID | BLFS_ROOT | BLFS_XML ) echo "`eval echo $PARAM_VALS`" ;;
271 TRACKING_DIR ) validate_dir -z -d -w ;;
272
273 esac
274 done
275 set -e
276 echo "${nl_}***${BOLD}${GREEN} ${PARAM_GROUP%%_*T} config parameters look good${OFF} ***${nl_}"
277}
Note: See TracBrowser for help on using the repository browser.